function [demographic_features] = get_demographics(current_header)

age_group=get_age(current_header);

if strcmpi(age_group,'neonate')
    age=0.5;
elseif strcmpi(age_group,'infant')
    age=6;
elseif strcmpi(age_group,'child')
    age=6*12;
elseif strcmpi(age_group,'adolescent')
    age=15*12;
elseif strcmpi(age_group,'young adult')
    age=20*12;
else
    age=0;
end

sex_group=get_sex(current_header);
if strcmpi(sex_group,'male')
    sex=0;
elseif strcmpi(sex_group,'female')
    sex=1;
else
    sex=2;
end

height=get_height(current_header);
weight=get_weight(current_header);

if (weight == 0) || (height == 0)
    BMI = 0;
else
    BMI = weight/(height/100)^2;
end

pregnancy = get_pregnancy(current_header);

demographic_features = [age;sex;height;weight;BMI;pregnancy];

end