function [net_NN,predictedLabels_NN,scores_NN] = train_NN(transformer_features_train_edited,Y_train_edited,transformer_features_test,Y_test)

numFeatures2 = size(transformer_features_train_edited,2);
layers2 = [
    featureInputLayer(numFeatures2,'Name','input',Normalization="zscore")
    fullyConnectedLayer(length(unique(Y_train_edited)), 'Name','fc')
    softmaxLayer('Name','sm')
    classificationLayer
    ];

options = trainingOptions('adam', ...
    'ExecutionEnvironment','gpu', ...
    'MaxEpochs',200, ...
    'MiniBatchSize',32, ...
    'InitialLearnRate',0.001, ...
    'LearnRateSchedule',"piecewise", ...
    'LearnRateDropFactor',0.1, ...
    'LearnRateDropPeriod',180, ...
    'L2Regularization',0.0001, ...
    'ValidationData',{transformer_features_test,Y_test}, ...
    'ValidationFrequency',100, ...
    'Shuffle','every-epoch', ...
    'Verbose',false,...
     'Plots','training-progress');
% ,...
%      'Plots','training-progress'
rng('default')
clear net_NN
[net_NN info] = trainNetwork(transformer_features_train_edited,Y_train_edited,layers2,options);
% 
% figure;
% A = activations(net2,train_signals_edited,'input');
% rng('default')
% [Y,loss] = tsne(A','Algorithm','exact','Distance','cosine','NumDimensions',2);
% gscatter(Y(:,1),Y(:,2),Y_train_edited,'grk')

[predictedLabels_NN,scores_NN] = classify(net_NN,transformer_features_test,'MiniBatchSize',32);

end