function [lgraph] = transformer_network_bigger(NumSignals,Y_train,weights)

%%% Input 1 layer
layer = sequenceInputLayer(NumSignals,MinLength=20000,Normalization="zscore",Name="input1");
lgraph = layerGraph(layer);

initializer = 'glorot';
% % % %%%%%%% With convolutions input separation
% % % for i = 1:4
% % %     layer = convolution1dLayer(1,1,Padding=0,WeightsInitializer=initializer,Name=['channel_',num2str(i),'_splitter']);
% % %     lgraph = addLayers(lgraph,layer);
% % %     lgraph = connectLayers(lgraph,'input1',['channel_',num2str(i),'_splitter']);
% % % end

% %%%%%%% Without convolutions input separation
% for selected_channel = 1:4
%     layer = channelSeparationLayer(selected_channel,['channel_',num2str(selected_channel),'_splitter']);
%     lgraph = addLayers(lgraph,layer);
%     lgraph = connectLayers(lgraph,'input1',['channel_',num2str(selected_channel),'_splitter']);
% end
% layer = channelSeparationLayer([5:34],['channel_',num2str(5),'_splitter']);
% lgraph = addLayers(lgraph,layer);
% lgraph = connectLayers(lgraph,'input1',['channel_',num2str(5),'_splitter']);
% 
% firstnumfilt = 4;
% for block_id = 1:4
% label = ['_block',num2str(block_id)];
% [lgraph] = network_blocks2(lgraph,firstnumfilt,label,block_id,initializer);
% end

%%%%%%% Select only used features
block_id = 1;
label = ['_block',num2str(block_id)];
firstnumfilt = 32;
[lgraph] = network_blocks22(lgraph,firstnumfilt,label,block_id,initializer);

% 
% dimension = 1;
% input_stream_1 = dimConcatLayer(5,dimension,'input_stream_1');
% % input_stream_1 = additionLayer(NumFeatures,'Name','input_stream_1');
% lgraph = addLayers(lgraph,input_stream_1);
% for i = 1:5
% lgraph = connectLayers(lgraph,['gapl_block',num2str(i)],['input_stream_1/in',num2str(i)]);
% end

%%% Final layer
layer = [fullyConnectedLayer(length(unique(Y_train)),WeightsInitializer=initializer,Name="fc_linear6"),...
         softmaxLayer(Name="sf_final"),...
         classificationLayer('Classes',unique(Y_train),'ClassWeights',weights,'Name','classification')];
% classificationLayer('Classes',unique(Y_train),'ClassWeights',weights,'Name','classification')
% regressionLayer('Name','regression')];
% ReshapeLayer("Name","reshape"),...

lgraph = addLayers(lgraph,layer);
lgraph = connectLayers(lgraph,['gapl',label],"fc_linear6");
% 
% analyzeNetwork(lgraph)


















% if NumSignals > 4
% %% Feature input layer (Comment if not needed)
% %%%%%%% Channel separation 
% selected_channel = 5;
% layer = channelSeparationLayer(selected_channel,['channel_',num2str(selected_channel),'_splitter']);
% lgraph = addLayers(lgraph,layer);
% lgraph = connectLayers(lgraph,'input1',['channel_',num2str(selected_channel),'_splitter']);
% 
% %%%%%%% Select only used features
% numextractedFeatures = 6;
% layer = featureSelectionLayer(numextractedFeatures,'feature_selection'); 
% lgraph = addLayers(lgraph,layer);
% lgraph = connectLayers(lgraph,['channel_',num2str(selected_channel),'_splitter'],'feature_selection');

% %%%%%%% Reshape to channel - batch
% layer = ReshapeLayer("Name","reshape");
% lgraph = addLayers(lgraph,layer);
% lgraph = connectLayers(lgraph,'feature_selection','reshape');
% 
% %%%%%%% Concatenate with transformer last layer
% dimension = 1;
% NumInputs = 2;
% input_stream_2 = dimConcatLayer(NumInputs,dimension,'input_stream_2');
% lgraph = addLayers(lgraph,input_stream_2);
% lgraph = connectLayers(lgraph,'input_stream_1',['input_stream_2/in',num2str(1)]);
% lgraph = connectLayers(lgraph,'reshape',['input_stream_2/in',num2str(2)]);
% lgraph = disconnectLayers(lgraph,'input_stream_1','fc_linear6');
% 
% %%%%%%% Normalization
% % layer = batchNormalizationLayer('Name','layernorm');
% % lgraph = addLayers(lgraph,layer);
% lgraph = connectLayers(lgraph,'input_stream_2','fc_linear6');
% % lgraph = connectLayers(lgraph,'layernorm','fc_linear6');
% 
% % analyzeNetwork(lgraph)
% 
% end

end

