classdef weightedAddition < nnet.layer.Layer
    % Example custom weighted addition layer.
    
    properties 

    end

    methods
        function layer = weightedAddition(numInputs,name) 
            % layer = weightedAddition(numInputs,name) creates a
            % weighted addition layer and specifies the number of inputs
            % and the layer name.

            % Set number of inputs.
            layer.NumInputs = numInputs;

            % Set layer name.
            layer.Name = name;

            % Set layer description.
            layer.Description = "Weighted addition layer";
        
            layer.Type = "Weighted Addition";
            
        end
        
        function Z = predict(~, varargin)
            % Z = predict(layer, X1, ..., Xn) forwards the input data X1,
            % ..., Xn through the layer and outputs the result Z.
            
            X = varargin;
            
            weighted_sum = X{1} + X{2};
            weighted_sum = weighted_sum./2;

            Z = weighted_sum;
           
        end
    end
end